<template>
  <div class="transaction-list-item">
    <div class="transaction-type-amount">
      <div class="transaction-type" v-if="transaction.type === 'receive'">
        Received from
        <span v-if="otherPersonHandle">@{{ otherPersonHandle }}</span>
      </div>
      <div class="transaction-type" v-else-if="transaction.type === 'send'">
        Sent to
        <span v-if="otherPersonHandle">@{{ otherPersonHandle }}</span>
      </div>
      <div class="transaction-type" v-if="transaction.type === 'claim'">Claimed</div>
      {{ transaction.senderOrReceiverHandle }}
      <div
        v-if="transaction.type === 'receive'"
        class="transaction-amount receive-amount"
      >+ {{ transaction.amount }}</div>
      <div
        v-else-if="transaction.type === 'send'"
        class="transaction-amount send-amount"
      >- {{ transaction.amount }}</div>
      <div
        v-else-if="transaction.type === 'claim'"
        class="transaction-amount claim-amount"
      >+ {{ transaction.amount }}</div>
    </div>
    <div class="timestamp">{{ timestamp }}</div>
  </div>
</template>

<script>
import moment from "moment";
import utils from "../assets/utils";
export default {
  props: ["transaction"],
  data: function() {
    return {
      otherPersonHandle: null
    };
  },
  computed: {
    timestamp() {
      return moment(this.transaction.timestamp).calendar();
    }
  },
  async mounted() {
    if(this.transaction) this.otherPersonHandle = await utils.getHandle(this.transaction.otherPersonAddress)
  }
};
</script>

<style>
.transaction-list-item {
  width: 100%;
  display: flex;
  flex-direction: column;
}
.transaction-list-item .transaction-type-amount {
  width: 100%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}
.transaction-list-item .transaction-type-amount .transaction-type {
  font-size: 13px;
  font-weight: bold;
}
.transaction-list-item .timestamp {
  font-size: 11px;
}
.transaction-list-item .transaction-amount {
  font-weight: normal;
  font-size: 18px;
  padding-right: 15px;
}
.transaction-list-item .transaction-amount.receive-amount {
  color: #74bd74;
}
.transaction-list-item .transaction-amount.send-amount {
  color: red;
}
.transaction-list-item .transaction-amount.claim-amount {
  color: green;
}
</style>
